/* Einartas Jonas Globis, PS 5.1 */
#ifndef BTREE_H_INCLUDED
#define BTREE_H_INCLUDED
struct tree
{
    void *data;
    int label;
    struct tree *top;
    int side;
    struct tree *left;
    struct tree *right;
};
typedef struct tree *branch;

struct root
{
    struct tree *element;
};
typedef struct root root;

branch CreateTree();
    /*Automatically creates new binary search tree.
    Output: binary tree root pointer (branch) */
branch DeleteTree(branch pointer);
    /*Deletes a created binary search tree.
    Input: binary tree root pointer.    (Output: NULL pointer)*/
branch SearchValue(int searchedvalue, branch pointer);
    /*Finds a tree branch with a specific label and returns it's pointer.
    Output: Pointer of returned label.Returns NULL if label is not present. Returns -1 on error.*/
branch SearchHighest(branch pointer);
    /*Finds the highest value in the binary tree.
    Input: binary tree root pointer.
    Output: highest tree element pointer.*/
branch SearchLowest(branch pointer);
    /*Finds the lowest value in the binary tree.
    Input: binary tree root pointer.
    Output: lowest tree element pointer.*/
int InsertValue(int insertedvalue, void* inserteddata, branch pointer);
    /*Inserts a new element into the binary tree.
    Input: insertedvalue - label for sorting; inserteddata - secondary data, pointer - binary tree root pointer.
    Output: Returns 1 if insertion succeeded. Returns 0 if element is already present. Returns -1 on error.*/
branch ExtractValue(int extractedvalue, branch pointer);
    /*Extracts an element from a binary tree.
    Input: extractedvalue - label to find element; pointer- binary tree root pointer.
    Output: Pointer to element extracted from binary tree. Returns NULL if element is not present. Returns -1 on error.*/
int CheckFull();
    /*Checks if a new binary tree element can be created.
    Output: Returns 1 if possible. Returns 0 if tree is full.*/
branch BalanceTree(branch *pointer);
    /*Balances the binary search tree.
    Input: binary tree root pointer adress.
    Output: new binary tree root pointer.*/
#endif
