#include <stdio.h>
#include <stdlib.h>
#ifndef vector_h
#define vector_h

//In order to change stored data type change typedef
typedef int DataType;
struct Cell
{
  DataType data;
  struct Cell *next;
};
struct Vector
{
  struct Cell *start;
  int state;//(-1) - Empty, 0 - Not empty, 1 - Deleted
};
typedef struct Vector Vector;

//On return: 0 - Vector is empty, 1 - Vector is not empty, -1 - Vector is deleted
int IsEmpty(Vector *head);

//On return: value in specified position//If position does'n exist returns -1//If vector doesn't exist returns 1
int GetElementValue(Vector **head, int position);

//On return: Vector size
int GetSize(Vector *head);

//Deletes Vector
int DeleteVector(Vector **head);

//Inserts element in specific place//If position doesn't exist returns -1
int InsertElement(Vector **head, int position, DataType value);

//Deletes specified element//If position doesn't exist returns -1//If vector doesn't exist returns 1
int DeleteElement(Vector **head, int position);

//Adds an element to a Vector(last position), returns -1 if vector is deleted or doesn't exist
int AddElement(Vector *head, DataType value);

//Changes element's value//If position doesn't exist returns -1//If vector doesn't exist returns 1
int ChangeElement(Vector *head, int position, DataType value);

//Prints Vector (0 untill end of Vector);
void print(Vector *head);
#endif
