#include "Vector.h"
//Sukuria tuscia vektoriu
void CreateVector(Vector **head)
{
  Vector *curr=NULL;
  curr=(Vector*)malloc(sizeof(Vector));
  curr->start=NULL;
  curr->state=-1;
  *head=curr;
}
//Patikrina ar vektorius tuscias
int IsEmpty(Vector *head)
{
  if(head==NULL)return -2;
  if(head->state==-1)
    return 0;
  else if(head->state==0)
    return 1;
  else if(head->state==1)
    return -1;
}

//Spausdina nurodyta vektoriu
void print(Vector *head)
{
  if(IsEmpty(head)==0 || IsEmpty(head)==-1 || head==NULL)
  {
    printf("Nothing to print.\n");
    return -1;
  }
  struct Cell *temp = head->start;
  printf("Printing Vector:\n---------------\n");
  int i=0;
  while(temp!=NULL)
  {
    printf("%d element is %d\n", i, temp->data);
    temp=temp->next;
    i++;
  }
  printf("---------------\n");
}

//Prideda nauja elementa vektoriaus pabaigoje
int AddElement(Vector *head, DataType value)
{
  if(IsEmpty(head)==-1 ||head==NULL)
    return -1;
  struct Cell *curr=head->start;
  if(IsEmpty(head)==0)
  {
    curr=(struct Cell*)malloc(sizeof(struct Cell));
    curr->data=value;
    curr->next=NULL;
    head->start=curr;
    head->state=0;
  }
  else
  {
    curr=head->start;
    while(curr->next!=NULL)
    {
      curr=curr->next;
    }
    curr->next=(struct Cell*)malloc(sizeof(struct Cell));
    curr=curr->next;
    curr->data=value;
    curr->next=NULL;
  }
}

//Istrina elementa nurodytoje pozicijoje
int DeleteElement(Vector **head, int position)
{
  if(*head==NULL)return 1;
  if(GetSize(*head)<position)
  {
    //printf("Element does not exist!\n");
    return -1;
  }
  struct Cell *temp=NULL;
  struct Cell *temp2=NULL;
  temp=(*head)->start;
  int c=-1;
  while(temp!=NULL)
  {
    c++;
    if(c==position)
    {
      break;
    }
    temp2=temp;
    temp=temp->next;
  }
  if(c==0)
  {
    *head=temp->next;
    free(temp);
  }
  else
  {
    temp2->next=temp->next;
    free(temp);
  }
}

//Iterpia nauja elementa nurodytoje pozicijoje
int InsertElement(Vector **head, int position, DataType value)
{
  if(*head==NULL)return 1;
  if(GetSize(*head)<position)
  {
    printf("Cannot insert element there!\n");
    return -1;
  }
  struct Cell *temp=NULL;
  struct Cell *temp2=NULL;
  temp=(*head)->start;
  int c=-1;
  while(temp!=NULL)
  {
    c++;
    if(c==position)
    {
      break;
    }
    temp2=temp;
    temp=temp->next;
  }
  if(c==0)
  {
    struct Cell *newCell=(struct Cell*)malloc(sizeof(struct Cell));
    newCell->data=value;
    newCell->next=temp;
    *head=newCell;
  }
  else
  {
    struct Cell *newCell=(struct Cell*)malloc(sizeof(struct Cell));
    newCell->data=value;
    newCell->next=temp;
    temp2->next=newCell;
  }
}

//Pakeicia elemento reiksme nurodytoje pozicijoje
int ChangeElement(Vector *head, int position, DataType value)
{
  if(head==NULL)return 1;
  if(GetSize(head)<=position)
  {
    printf("Element does not exist!\n");
    return -1;
  }
  struct Cell *temp=head->start;
  while(position!=NULL)
  {
    temp=temp->next;
    position--;
  }
  temp->data=value;
}

//Grazina vektoriaus elemento reiksme nurodytoje pozicijoje
int GetElementValue(Vector *head, int position)
{
  if(head==NULL)return 1;
  if(GetSize(head)<=position)
  {
    printf("Element does not exist!\n");
    return -1;
  }
  struct Cell *temp=(head)->start;
  while(position!=NULL)
  {
    temp=temp->next;
    position--;
  }
  return temp->data;
}

//Grazina nurodyto vektoriaus dydi
int GetSize(Vector *head)
{
  if(head==NULL)return -1;
  int c=0;
  struct Cell *temp=head->start;
  while(temp!=NULL)
  {
    temp=temp->next;
    c++;
  }
  return c;
}

//Isvalo vektoriu
int DeleteVector(Vector **head)
{
  if(*head==NULL)return 1;
    struct Cell *next, *deleteMe;
    deleteMe=(*head)->start;
    while (deleteMe)
    {
      next=deleteMe->next;
      free(deleteMe);
      deleteMe=next;
    }
    (*head)->state=1;
}
