//-------------------------------------------Arnas Ambrasas 2gr.-------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "adtbinarytree.h"

Tree *createTree(Tree *tree, int *error) {
  if(tree!=NULL) {
    *error = 1;
    return tree;
  }
  if (tree = (Tree*)malloc(sizeof(Tree))){
    tree->root = NULL;
    tree->size = 0;
    return tree;
  }
  else {
    *error = 2;
    return NULL;
  }
}

Tree *deleteTree(Tree *tree) {
  tree->root = deleteNodes(tree->root);
  free(tree);
  return NULL;
}

int insert(Tree *tree, bstDataValue value) {
  int a = 0;
  if(!tree)
    return 1;

  a = insertNode(&(tree->root), value, 0);
  if(a == 2)
    return 2;
  else if(a == 3)
    return 3;
  else {
    tree->size++;
    return 0;
  }
}


int insertNode(Node ** root, bstDataValue value, int level) {
  Node *temp = NULL;

  if(!(*root)) {
    if(!(temp = (Node*) malloc(sizeof(Node))))
      return 2;
    temp->leftNode = temp->rightNode = NULL;
    temp->value = value;
    level++;
    temp->level = level;
    *root = temp;
    return 0;
  }
  if(value == (*root)->value)
    return 3;
  else if(value < (*root)->value) {
    insertNode(&(*root)->leftNode, value, (*root)->level);
  }
  else if(value > (*root)->value) {
    insertNode(&(*root)->rightNode, value, (*root)->level);
  }
}

int deleteTreeNode(Tree *tree, bstDataValue value) {
  int error = 0;
  if(tree == NULL || tree->root == NULL)
    return 1;
  tree->root = deleteNode(tree->root, value, &error);
  if(error) {
    tree->size--;
    return 0;
  }
  else return 2;
}

int getSize(Node *root) {
  if(!root)
    return 0;
  else
    return 1 + getSize(root->leftNode) + getSize(root->rightNode);
}


int getHeight(Node *root) {
  if(root == NULL)
    return 0;
  else {
    int leftSubTreeHeight = getHeight(root->leftNode);
    int rightSubTreeHeight = getHeight(root->rightNode);
    return leftSubTreeHeight > rightSubTreeHeight ? (leftSubTreeHeight + 1) : (rightSubTreeHeight + 1);
  }
}

void preOrderTraversal(Node *root) {
	if(root == NULL) return;

	printf("%d ", root->value);
	preOrderTraversal(root->leftNode);
  preOrderTraversal(root->rightNode);

}

void inOrderTraversal(Node *root) {
  if(root == NULL) return;

  inOrderTraversal(root->leftNode);
  printf("%d ", root->value);
  inOrderTraversal(root->rightNode);
}

void postOrderTraversal(Node *root) {
  if(root == NULL) return;

  postOrderTraversal(root->leftNode);
  postOrderTraversal(root->rightNode);
  printf("%d ", root->value);
}

void printLevel(Node *root, int level) {
  if(!root)
    return;
  if(level == 1)
    printf("%d ", root->value);
  else if(level > 1) {
    printLevel(root->leftNode, level - 1);
    printLevel(root->rightNode, level - 1);
  }
}

void levelTraversal(Node *root, int height) {
  int i;
  for(i = 1; i <= height; i++) {
    printLevel(root, i);
    printf("\n");
  }
}

void transformIntoArray(Node *root, bstDataValue A[], int *i){
    if(!root)
        return;

    transformIntoArray(root->leftNode, A, i);
    A[*i] = root->value;
    ++*i;
    transformIntoArray(root->rightNode, A, i);
}

void balance(Node **root) {
  int i = 0;
  int size = getSize(*root);
  bstDataValue A[size - 1];

  transformIntoArray(*root, A, &i);

  *root = deleteNodes(*root);
  *root = transformIntoTree(A, 0, size - 1);
}

Node *transformIntoTree(bstDataValue A[], int start, int end) {
  if(start > end)
    return NULL;
  int mid = (start + end)/2;
  Node *root = NULL;
  insertNode(&root, A[mid], 0);

  root->leftNode = transformIntoTree(A, start, mid - 1);
  root->rightNode = transformIntoTree(A, mid + 1, end);
  return root;
}

Node *getMin(Node *root) {
  if(!root->leftNode) return root;
  getMin(root->leftNode);
}

Node *getMax(Node *root) {
  if(!root->rightNode) return root;
  getMax(root->rightNode);
}

Node* deleteNode(Node *root, bstDataValue value, int *error) {
	if(root == NULL) return root;
	else if(value < root->value) root->leftNode = deleteNode(root->leftNode,value, error);
	else if (value > root->value) root->rightNode = deleteNode(root->rightNode, value, error);

	else {
    *error = 1;
		if(root->leftNode == NULL && root->rightNode == NULL) {
			free(root);
			root = NULL;
		}

		else if(root->leftNode == NULL) {
			Node *temp = root;
			root = root->rightNode;
			free(temp);
		}

		else if(root->rightNode == NULL) {
			Node *temp = root;
			root = root->leftNode;
			free(temp);
		}

		else {
			Node *temp = getMin(root->rightNode);
			root->value = temp->value;
			root->rightNode = deleteNode(root->rightNode, temp->value, error);
		}
	}
	return root;
}

Node *deleteNodes(Node *root) {
  if(root != NULL) {
    deleteNodes(root->leftNode);
    deleteNodes(root->rightNode);
    free(root);
  }
  return NULL;
}

Node *getElementByValue(Node *root, bstDataValue value, int *ptr) {
  //printf("%d ", value);
  if(root == NULL)
    return NULL;
  else if(root->value == value)
    return root;
  else if(root->rightNode == NULL && root->leftNode == NULL)
    return NULL;
  else if(value < root->value && root->leftNode == NULL)
    return NULL;
  else if(value > root->value && root->rightNode == NULL)
    return NULL;
  else if(value > root->value){
    getElementByValue(root->rightNode, value, ptr);
    (*ptr)++;
  }
  else if(value < root->value){
    getElementByValue(root->leftNode, value, ptr);
    (*ptr)++;
  }
}
