//-------------------------------------------Arnas Ambrasas 2gr.-------------------------------------------------------
/*
Procedūros/funkcijos, pirmąjame parametre turinčios Tree *tree, parametrą realizuojamos joms perduodant medžio adresą

Procedūros/funkcijos, pirmąjame parametre turinčios Node *root, parametrą realizuojamos joms perduodant medžio šaknies adresą,
Procedūra insertNode - medžio šaknies adreso adresą

Visos Node* tipo funcijos(išskyrus deleteNode, ir deleteNodes) gražina NULL pointerį jei programa klaidingai baigė darbą
*/
#ifndef ADT_BINARY_TREE_INCLUDED
#define ADT_BINARY_TREE_INCLUDED

typedef bstDataValue;

typedef struct StructNode {
bstDataValue value;
int level;
struct StructNode *rightNode, * leftNode;
}Node;

typedef struct StructTree {
  Node *root;
  int size;
}Tree;

Tree *createTree(Tree *tree, int *error);
/*
Sukuria naują medį, error'ų kodai išreiškiami kintamuoju error:1 - medis jau sukurtas
2 - Nepavyko išskirti atminties medžio struktūrai
*/
Tree *deleteTree(Tree *tree);
int insert(Tree *tree, bstDataValue value);
/* Įdėjimo procedūra, kuriai paduodamas medžio struktūros adresas, elementas įdedamas insertNode procedūra, jai perduodant medžio šaknies
adresą. Klaidų kodai gražinami per return:1 - medis nesukurtas
2 - Nepavyko išskirti atminties
3 - Toks elementas jau patalpintas
*/
int insertNode(Node ** root, bstDataValue value, int level);
/*
Elemento įdėjimo į medį procedūra, kuriai paduodamas medžio šaknies adreso adresas. Klaidų kodai gražinami per return:
1 - rezervuotas, nes šią klaidą aptinka insert procedūra
2 - Elementui nepavyko išskirti atminties
3 - Toks elementas jau patalpintas
Klaidas ji perduoda procedūrai insert, kurioje ši procedūra yra panaudojama.
*/
int deleteTreeNode(Tree *tree, bstDataValue value);
/*Medžio elemento trinimo procedūra, kuriai perduodamas medžio struktūros adresas, ir panaudojama deleteNode funkcija, kurioje
yra ieškomas ir ištrinamas medžio elementas, jai paduodant medžio šaknies adresą. Klaidų kodai gražinami per return:
1 - Medis tuščias
2 - Tokio elemento medyje nėra
*/
int getSize(Node *root);
int getHeight(Node *root);
void preOrderTraversal(Node *root);
void inOrderTraversal(Node *root);
void postOrderTraversal(Node *root);
void printLevel(Node *root, int level);
void levelTraversal(Node *root, int height);
void transformIntoArray(Node *root, bstDataValue A[], int *i);
/*
Procedūra visus medžio elementus, didėjimo tvarka surašanti į jo elementų tipo masyvą
*/
void balance(Node **root);
Node *transformIntoTree(bstDataValue A[], int start, int end);
Node *getMin(Node *root);
Node *getMax(Node *root);
Node* deleteNode(Node *root, bstDataValue value, int *error);
/*Elemento trinimo funkcija, naudojama deleteTreeNode procedūroje. Jai paduodamas medžio šaknies adresas. Klaidų kodai
grąžinami error kintamuoju, procedūrai deleteTreeNode:1 - medis tuščias
2 - tokio elemento nėra
*/
Node *deleteNodes(Node *root);
Node *getElementByValue(Node *root, bstDataValue value, int*ptr);

#endif
